<template>
  <div>
    <b-modal
      id="mergeUserModal"
      :title="
        $t('page.userprofile.mergeModal.title', { provider: providerToMerge })
      "
      :hide-footer="true"
      :static="true"
      :lazy="true"
    >
      <!-- Body -->
      <i18n-t scope="global" keypath="page.userprofile.mergeModal.body" tag="p">
        <template #logout>
          <strong>{{ $t("page.userprofile.mergeModal.logout") }}</strong>
        </template>
        <template #login>
          <strong>
            {{
              $t("page.userprofile.mergeModal.login", {
                provider: providerToMerge,
              })
            }}
          </strong>
        </template>
      </i18n-t>
      <br />
      <span>
        {{ $t("page.userprofile.mergeModal.ready") }}
      </span>

      <!-- Buttons -->
      <div class="mt-3">
        <!-- Confirm Button -->
        <b-button
          id="logOutForMerge"
          class="mergeUserModalRightBtn float-end"
          variant="primary"
          @click="proceedWithMerge"
        >
          {{ $t("nav.userLogOut") }}
        </b-button>

        <!-- Cancel Button -->
        <b-button
          class="mergeUserModalLeftBtn"
          variant="secondary"
          @click="mergeUserModal.hide()"
        >
          {{ $t("buttons.cancel") }}
        </b-button>
      </div>
    </b-modal>
  </div>
</template>

<script lang="ts">
import useLoginStore from "@/modules/login/store";
import useUserStore from "../../store";

import { useModal } from "bootstrap-vue-next";

import type { IdentityProviders } from "@coscine/api-client/dist/types/Coscine.Api";

export default defineComponent({
  props: {
    providerToMerge: {
      default: null,
      type: String as PropType<IdentityProviders | null>,
    },
  },
  setup() {
    const loginStore = useLoginStore();
    const userStore = useUserStore();

    const mergeUserModal = useModal("mergeUserModal");

    return { loginStore, userStore, mergeUserModal };
  },
  methods: {
    async proceedWithMerge() {
      if (this.providerToMerge) {
        await this.userStore.initiateUserMerge(this.providerToMerge); // Merge JWT token stored in the cookies for STS
        // Log user out. After initiating an ORCID login, the STS will do the merge job.
        this.loginStore.logout();
      }
    },
  },
});
</script>

<style scoped></style>
